
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "option",
    "neuStart",
    "intervall"
})
public class StartArt implements Serializable
{

    @JsonProperty("option")
    private StartArt.Option option = StartArt.Option.fromValue("automatisch");
    @JsonProperty("neuStart")
    private Boolean neuStart = true;
    @JsonProperty("intervall")
    private String intervall;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -236667569261984577L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartArt() {
    }

    /**
     * 
     * @param neuStart
     * @param intervall
     * @param option
     */
    public StartArt(StartArt.Option option, Boolean neuStart, String intervall) {
        super();
        this.option = option;
        this.neuStart = neuStart;
        this.intervall = intervall;
    }

    @JsonProperty("option")
    public StartArt.Option getOption() {
        return option;
    }

    @JsonProperty("option")
    public void setOption(StartArt.Option option) {
        this.option = option;
    }

    public StartArt withOption(StartArt.Option option) {
        this.option = option;
        return this;
    }

    @JsonProperty("neuStart")
    public Boolean getNeuStart() {
        return neuStart;
    }

    @JsonProperty("neuStart")
    public void setNeuStart(Boolean neuStart) {
        this.neuStart = neuStart;
    }

    public StartArt withNeuStart(Boolean neuStart) {
        this.neuStart = neuStart;
        return this;
    }

    @JsonProperty("intervall")
    public String getIntervall() {
        return intervall;
    }

    @JsonProperty("intervall")
    public void setIntervall(String intervall) {
        this.intervall = intervall;
    }

    public StartArt withIntervall(String intervall) {
        this.intervall = intervall;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartArt withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(StartArt.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("option");
        sb.append('=');
        sb.append(((this.option == null)?"<null>":this.option));
        sb.append(',');
        sb.append("neuStart");
        sb.append('=');
        sb.append(((this.neuStart == null)?"<null>":this.neuStart));
        sb.append(',');
        sb.append("intervall");
        sb.append('=');
        sb.append(((this.intervall == null)?"<null>":this.intervall));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.neuStart == null)? 0 :this.neuStart.hashCode()));
        result = ((result* 31)+((this.intervall == null)? 0 :this.intervall.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.option == null)? 0 :this.option.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartArt) == false) {
            return false;
        }
        StartArt rhs = ((StartArt) other);
        return (((((this.neuStart == rhs.neuStart)||((this.neuStart!= null)&&this.neuStart.equals(rhs.neuStart)))&&((this.intervall == rhs.intervall)||((this.intervall!= null)&&this.intervall.equals(rhs.intervall))))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.option == rhs.option)||((this.option!= null)&&this.option.equals(rhs.option))));
    }

    public enum Option {

        AUTOMATISCH("automatisch"),
        MANUELL("manuell"),
        INTERVALLRELATIV("intervallrelativ"),
        INTERVALLABSOLUT("intervallabsolut");
        private final String value;
        private final static Map<String, StartArt.Option> CONSTANTS = new HashMap<String, StartArt.Option>();

        static {
            for (StartArt.Option c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Option(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static StartArt.Option fromValue(String value) {
            StartArt.Option constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
