
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "nachfolger",
    "rechner",
    "wartezeit"
})
public class StoppBedingung implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("nachfolger")
    private List<String> nachfolger = new ArrayList<String>();
    @JsonProperty("rechner")
    private String rechner;
    @JsonProperty("wartezeit")
    private String wartezeit;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 630552199889244899L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StoppBedingung() {
    }

    /**
     * 
     * @param rechner
     * @param wartezeit
     * @param nachfolger
     */
    public StoppBedingung(List<String> nachfolger, String rechner, String wartezeit) {
        super();
        this.nachfolger = nachfolger;
        this.rechner = rechner;
        this.wartezeit = wartezeit;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("nachfolger")
    public List<String> getNachfolger() {
        return nachfolger;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("nachfolger")
    public void setNachfolger(List<String> nachfolger) {
        this.nachfolger = nachfolger;
    }

    public StoppBedingung withNachfolger(List<String> nachfolger) {
        this.nachfolger = nachfolger;
        return this;
    }

    @JsonProperty("rechner")
    public String getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(String rechner) {
        this.rechner = rechner;
    }

    public StoppBedingung withRechner(String rechner) {
        this.rechner = rechner;
        return this;
    }

    @JsonProperty("wartezeit")
    public String getWartezeit() {
        return wartezeit;
    }

    @JsonProperty("wartezeit")
    public void setWartezeit(String wartezeit) {
        this.wartezeit = wartezeit;
    }

    public StoppBedingung withWartezeit(String wartezeit) {
        this.wartezeit = wartezeit;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StoppBedingung withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(StoppBedingung.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("nachfolger");
        sb.append('=');
        sb.append(((this.nachfolger == null)?"<null>":this.nachfolger));
        sb.append(',');
        sb.append("rechner");
        sb.append('=');
        sb.append(((this.rechner == null)?"<null>":this.rechner));
        sb.append(',');
        sb.append("wartezeit");
        sb.append('=');
        sb.append(((this.wartezeit == null)?"<null>":this.wartezeit));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.rechner == null)? 0 :this.rechner.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.wartezeit == null)? 0 :this.wartezeit.hashCode()));
        result = ((result* 31)+((this.nachfolger == null)? 0 :this.nachfolger.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StoppBedingung) == false) {
            return false;
        }
        StoppBedingung rhs = ((StoppBedingung) other);
        return (((((this.rechner == rhs.rechner)||((this.rechner!= null)&&this.rechner.equals(rhs.rechner)))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.wartezeit == rhs.wartezeit)||((this.wartezeit!= null)&&this.wartezeit.equals(rhs.wartezeit))))&&((this.nachfolger == rhs.nachfolger)||((this.nachfolger!= null)&&this.nachfolger.equals(rhs.nachfolger))));
    }

}
