
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "name",
    "aenderungsgrund",
    "skript",
    "veranlasser",
    "passwort",
    "restart"
})
public class VersionierungsRequest implements Serializable
{

    @JsonProperty("name")
    private String name;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsgrund")
    private String aenderungsgrund;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("skript")
    private StartStoppSkript skript;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("veranlasser")
    private String veranlasser;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passwort")
    private String passwort;
    @JsonProperty("restart")
    private Boolean restart = true;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -829499235561748162L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public VersionierungsRequest() {
    }

    /**
     * 
     * @param passwort
     * @param skript
     * @param restart
     * @param veranlasser
     * @param name
     * @param aenderungsgrund
     */
    public VersionierungsRequest(String name, String aenderungsgrund, StartStoppSkript skript, String veranlasser, String passwort, Boolean restart) {
        super();
        this.name = name;
        this.aenderungsgrund = aenderungsgrund;
        this.skript = skript;
        this.veranlasser = veranlasser;
        this.passwort = passwort;
        this.restart = restart;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public VersionierungsRequest withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsgrund")
    public String getAenderungsgrund() {
        return aenderungsgrund;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsgrund")
    public void setAenderungsgrund(String aenderungsgrund) {
        this.aenderungsgrund = aenderungsgrund;
    }

    public VersionierungsRequest withAenderungsgrund(String aenderungsgrund) {
        this.aenderungsgrund = aenderungsgrund;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("skript")
    public StartStoppSkript getSkript() {
        return skript;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("skript")
    public void setSkript(StartStoppSkript skript) {
        this.skript = skript;
    }

    public VersionierungsRequest withSkript(StartStoppSkript skript) {
        this.skript = skript;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("veranlasser")
    public String getVeranlasser() {
        return veranlasser;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("veranlasser")
    public void setVeranlasser(String veranlasser) {
        this.veranlasser = veranlasser;
    }

    public VersionierungsRequest withVeranlasser(String veranlasser) {
        this.veranlasser = veranlasser;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passwort")
    public String getPasswort() {
        return passwort;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passwort")
    public void setPasswort(String passwort) {
        this.passwort = passwort;
    }

    public VersionierungsRequest withPasswort(String passwort) {
        this.passwort = passwort;
        return this;
    }

    @JsonProperty("restart")
    public Boolean getRestart() {
        return restart;
    }

    @JsonProperty("restart")
    public void setRestart(Boolean restart) {
        this.restart = restart;
    }

    public VersionierungsRequest withRestart(Boolean restart) {
        this.restart = restart;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public VersionierungsRequest withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(VersionierungsRequest.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("name");
        sb.append('=');
        sb.append(((this.name == null)?"<null>":this.name));
        sb.append(',');
        sb.append("aenderungsgrund");
        sb.append('=');
        sb.append(((this.aenderungsgrund == null)?"<null>":this.aenderungsgrund));
        sb.append(',');
        sb.append("skript");
        sb.append('=');
        sb.append(((this.skript == null)?"<null>":this.skript));
        sb.append(',');
        sb.append("veranlasser");
        sb.append('=');
        sb.append(((this.veranlasser == null)?"<null>":this.veranlasser));
        sb.append(',');
        sb.append("passwort");
        sb.append('=');
        sb.append(((this.passwort == null)?"<null>":this.passwort));
        sb.append(',');
        sb.append("restart");
        sb.append('=');
        sb.append(((this.restart == null)?"<null>":this.restart));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.passwort == null)? 0 :this.passwort.hashCode()));
        result = ((result* 31)+((this.skript == null)? 0 :this.skript.hashCode()));
        result = ((result* 31)+((this.restart == null)? 0 :this.restart.hashCode()));
        result = ((result* 31)+((this.veranlasser == null)? 0 :this.veranlasser.hashCode()));
        result = ((result* 31)+((this.name == null)? 0 :this.name.hashCode()));
        result = ((result* 31)+((this.aenderungsgrund == null)? 0 :this.aenderungsgrund.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof VersionierungsRequest) == false) {
            return false;
        }
        VersionierungsRequest rhs = ((VersionierungsRequest) other);
        return ((((((((this.passwort == rhs.passwort)||((this.passwort!= null)&&this.passwort.equals(rhs.passwort)))&&((this.skript == rhs.skript)||((this.skript!= null)&&this.skript.equals(rhs.skript))))&&((this.restart == rhs.restart)||((this.restart!= null)&&this.restart.equals(rhs.restart))))&&((this.veranlasser == rhs.veranlasser)||((this.veranlasser!= null)&&this.veranlasser.equals(rhs.veranlasser))))&&((this.name == rhs.name)||((this.name!= null)&&this.name.equals(rhs.name))))&&((this.aenderungsgrund == rhs.aenderungsgrund)||((this.aenderungsgrund!= null)&&this.aenderungsgrund.equals(rhs.aenderungsgrund))))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))));
    }

}
